/**
  * @file ltc4260.h
  * @author generated by mrt-device utility 
  * @link [https://mrt.readthedocs.io/en/latest/pages/mrtutils/mrt-device.html]
  * @brief Device driver for LTC4260 device
  *
  *
  */

#ifdef __cplusplus
extern "C"
{
#endif

/* Includes ------------------------------------------------------------------*/
#include <stdint.h>
#include <stdbool.h>
#include "Devices/RegDevice/register_device.h"
#include "ltc4260_regs.h"

/*user-block-top-start*/

#define LTC4260_SENSE_VOLTAGE_LSB_UV 300
#define LTC4260_SOURCE_VOTLAGE_LSB_MV 400
#define LTC4260_ADIN_VOLTAGE_LSB_MV 10
/*user-block-top-end*/


/* Exported types ------------------------------------------------------------*/

typedef struct{
    mrt_regdev_t mRegDev;            //ptr to base register-device 
    mrt_reg_t mControl;              //Control Register
    mrt_reg_t mAlert;                //Alert Register
    mrt_reg_t mStatus;               //System status information
    mrt_reg_t mFault;                //Fault Log
    mrt_reg_t mSense;                //ADC Current Sense Voltage Data
    mrt_reg_t mSource;               //ADC Source votlage Data
    mrt_reg_t mAdin;                 //ADC ADIN Voltage Data
/*user-block-struct-start*/
/*user-block-struct-end*/
}ltc4260_t;


/* Exported functions ------------------------------------------------------- */


/**
 * @brief initializes LTC4260 device for i2c bus
 * @param dev ptr to LTC4260 device
 * @param i2c handle for i2c bus
 */
mrt_status_t ltc4260_init_i2c(ltc4260_t* dev, mrt_i2c_handle_t i2c);

/**
  *@brief tests interface with device
  *@param dev ptr to LTC4260 device
  *@return MRT_STATUS_OK if test is passed 
  *@return MRT_STATUS_ERROR if test fails
  */
mrt_status_t ltc4260_test(ltc4260_t* dev);

/**
  *@brief writes register of device
  *@param dev ptr to LTC4260 device
  *@param reg ptr to register definition
  *@param data data to be write
  *@return status (type defined by platform)
  */
#define ltc4260_write_reg(dev, reg, data) regdev_write_reg(&(dev)->mRegDev, (reg), (data))

/**
  *@brief reads register of device
  *@param dev ptr to LTC4260 device
  *@param reg ptr to register definition
  *@param data ptr to store data
  *@return value of register
  */
#define ltc4260_read_reg(dev, reg) regdev_read_reg(&(dev)->mRegDev, (reg))


/*user-block-bottom-start*/

/**
 * @brief sets the fet state for the device
 * 
 * @param dev ptr to LTC4260 device  
 * @param state state of fet (0 = off, 1 = on)
 * @return mrt_status_t 
 */
mrt_status_t ltc4260_set_fet(ltc4260_t* dev, uint8_t state);

/**
 * @brief Sets the address of a device instance
 * @param dev ptr to LTC4260 device 
 * @param address 8bit I2C address of device
 * @return mrt_status_t 
 */
mrt_status_t ltc4260_set_i2c_address(ltc4260_t* dev, uint8_t address);

/**
 * @brief Get the current sense voltage
 * @param dev ptr to LTC4260 device 
 * @return voltage in mV
 */
float ltc4260_get_sense_voltage(ltc4260_t* dev);

/**
 * @brief Get the source voltage
 * @param dev ptr to LTC4260 device 
 * @return voltage in mV
 */
float ltc4260_get_source_voltage(ltc4260_t* dev);

/**
 * @brief Get the ADIN voltage
 * @param dev ptr to LTC4260 device 
 * @return voltage in mV
 */
float ltc4260_get_adin_voltage(ltc4260_t* dev);

/*user-block-bottom-end*/

#ifdef __cplusplus
}
#endif